// Swirl Applet 1998 Romain GUY
// powerteam@chez.com
// www.chez.com/powerteam

// What I used to optimize refresh rate:
// 	- Overloading: public void update(Graphics g)
//	- Double-buffering
//	- Threads

import java.net.*;
import java.awt.Font;
import java.awt.Color;
import java.awt.Event;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.FontMetrics;

public class Swirl extends java.applet.Applet implements Runnable
{
  protected int fontSize;
  protected String fontef;
  protected String mssg;
  protected Font f;
  protected int col, l, red, green, blue;
  protected Image offScreenImg;
  protected Graphics offScreen;
  protected Color old;
  protected Thread runner;

  public void init()
  {
    String colorss = getParameter("colors");
    if (colorss == null)
      col = 255;
    else
    {
      try
      {
        if (Integer.parseInt(colorss) < 50)
	  col = 50;
	if (Integer.parseInt(colorss) > 255)
	  col = 255;
	col = Integer.parseInt(colorss);
      }
      catch (Throwable t)
      {
        col = 255;
      }
    }
    String size = getParameter("size");
    if (size == null)
      fontSize = 48;
    else
    {
      try
      {
        fontSize = Integer.parseInt(size);
      }
      catch (Throwable t)
      {
        fontSize = 48;
      }
    }
    String fonte = getParameter("font");
    if (fonte == null)
      fontef = "Arial";
    else
      fontef = fonte;
    String msg = getParameter("msg");
    if (msg == null)
      mssg = "Hello World !";
    else
      mssg = msg;
    String reds = getParameter("red");
    if (reds == null)
      red = 255;
    else
    {
      try
      {
        red = Integer.parseInt(reds);
      }
      catch (Throwable t)
      {
        red = 255;
      }
    }
    String greens = getParameter("green");
    if (greens == null)
      green = 255;
    else
    {
      try
      {
        green = Integer.parseInt(greens);
      }
      catch (Throwable t)
      {
        green = 255;
      }
    }
    String blues = getParameter("blue");
    if (blues == null)
      blue = 255;
    else
    {
      try
      {
        blue = Integer.parseInt(blues);
      }
      catch (Throwable t)
      {
        blue = 255;
      }
    }
    setBackground(new Color(red, green, blue));
    f = new Font(fontef, Font.BOLD, fontSize);
    FontMetrics fm = getFontMetrics(f);
    l = (size().width - fm.stringWidth(mssg)) / 2;
    offScreenImg = createImage(size().width, size().height);
    offScreen = offScreenImg.getGraphics();
    offScreen.setFont(f);
  }

  public void start()
  {
    if (runner == null)
    {
      runner = new Thread(this);
      runner.start();
    }
  }

  public void stop()
  {
    runner = null;
  }

  public void run()
  {
    Color colors[] = new Color[col];
    float c = 0;
    for (int i = 0; i < colors.length; i++)
    {
      colors[i] = Color.getHSBColor(c, (float)1.0, (float)1.0);
      c += 1.0 / col;
    }

    int i = 0;
    Thread thisThread = Thread.currentThread();
    while (runner == thisThread)
    {
      offScreen.setColor(colors[i]);
      old = offScreen.getColor();
      repaint();
      i++;
      try
      {
        Thread.sleep(200);
      }
      catch (InterruptedException e)
      {
      }
      if (i == colors.length) i = 0;
    }
  }

  public String getAppletInfo()
  {
    return("Swirl 1998 Romain GUY");
  }

  public void repaint()
  {
    update(getGraphics());
  }
  
  public void update(Graphics g)
  {
    offScreen.setColor(Color.white);
    offScreen.drawString(mssg, l, 50);
    offScreen.setColor(old);
    paint(g);
  }

  public void paint(Graphics g)
  {
    offScreen.drawString(mssg, l, 50);
    g.drawImage(offScreenImg, 0, 0, this);
  }

  public boolean mouseEnter(Event evt, int x, int y)
  {
    getAppletContext().showStatus("Swirl 1998 Romain GUY");
    return true;
  }

  public boolean mouseDown(Event evt, int x, int y)
  {
    try
    {
      getAppletContext().showDocument(new URL("http://www.chez.com/powerteam"));
    }
    catch (MalformedURLException e)
    {
    }
    return true;
  }

  public void destroy()
  {
    offScreen.dispose();
  }
}

// End of Source Code
